/*
ssc (static site checker)
Copyright (c) 2020 Dylan Harris
https://dylanharris.org/

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public Licence as published by
the Free Software Foundation, either version 3 of the Licence,  or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public Licence for more details.

You should have received a copy of the GNU General Public
Licence along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
*/

#pragma once

#include "attribute.h"

// typedef typed_attribute < e_attribute, t_unknown, a_unknown > attr_unknown;
typedef typed_attribute < e_attribute, t_generic, a_abbr > attr_abbr;
typedef typed_attribute < e_attribute, t_generic, a_accept > attr_accept;
typedef typed_attribute < e_attribute, t_generic, a_acceptcharset > attr_acceptcharset;
typedef typed_attribute < e_attribute, t_key, a_accesskey > attr_accesskey;
typedef typed_attribute < e_attribute, t_url, a_action > attr_action;
typedef typed_attribute < e_attribute, t_boolean, a_allowfullscreen > attr_allowfullscreen;
typedef typed_attribute < e_attribute, t_boolean, a_allowpaymentrequest > attr_allowpaymentrequest;
typedef typed_attribute < e_attribute, t_boolean, a_allowusermedia > attr_allowusermedia;
typedef typed_attribute < e_attribute, t_text, a_alt > attr_alt;
typedef typed_attribute < e_attribute, t_aria, a_ariastar > attr_ariastar;
typedef typed_attribute < e_attribute, t_as, a_as > attr_as;
typedef typed_attribute < e_attribute, t_boolean, a_async > attr_async;
typedef typed_attribute < e_attribute, t_autocapitalise, a_autocapitalise > attr_autocapitalise;
typedef typed_attribute < e_attribute, t_generic, a_autocomplete > attr_autocomplete;
typedef typed_attribute < e_attribute, t_existential, a_autoplay > attr_autoplay;
typedef typed_attribute < e_attribute, t_boolean, a_autofocus > attr_autofocus;
typedef typed_attribute < e_attribute, t_1, a_border > attr_border;
typedef typed_attribute < e_attribute, t_capture, a_capture > attr_capture;
typedef typed_attribute < e_attribute, t_capture, a_checked > attr_checked;
typedef typed_attribute < e_attribute, t_charset, a_charset > attr_charset;
typedef typed_attribute < e_attribute, t_url, a_cite > attr_cite;
typedef typed_attribute < e_attribute, t_tokens, a_class > attr_class;
typedef typed_attribute < e_attribute, t_generic, a_classid > attr_classid;
typedef typed_attribute < e_attribute, t_generic, a_codebase > attr_codebase;
typedef typed_attribute < e_attribute, t_unsigned, a_cols > attr_cols;
typedef typed_attribute < e_attribute, t_unsigned, a_colspan > attr_colspan;
typedef typed_attribute < e_attribute, t_coords, a_coords > attr_coords;
typedef typed_attribute < e_attribute, t_generic, a_content > attr_content;
typedef typed_attribute < e_attribute, t_truefalse, a_contenteditable > attr_contenteditable;
typedef typed_attribute < e_attribute, t_boolean, a_controls > attr_controls;
typedef typed_attribute < e_attribute, t_cors, a_crossorigin > attr_crossorigin;
typedef typed_attribute < e_attribute, t_url, a_data > attr_data;
typedef typed_attribute < e_attribute, t_data, a_datastar > attr_datastar;
typedef typed_attribute < e_attribute, t_date, a_datetime > attr_datetime;
typedef typed_attribute < e_attribute, t_boolean, a_defer > attr_defer;
typedef typed_attribute < e_attribute, t_boolean, a_default > attr_default;
typedef typed_attribute < e_attribute, t_decoding, a_decoding > attr_decoding;
typedef typed_attribute < e_attribute, t_generic, a_dirname > attr_dirname;
typedef typed_attribute < e_attribute, t_dir, a_dir > attr_dir;
typedef typed_attribute < e_attribute, t_boolean, a_disabled > attr_disabled;
typedef typed_attribute < e_attribute, t_boolean, a_disableremoteplayback > attr_disableremoteplayback;
typedef typed_attribute < e_attribute, t_filename, a_download > attr_download;
typedef typed_attribute < e_attribute, t_truefalse, a_draggable > attr_draggable;
typedef typed_attribute < e_attribute, t_enctype, a_enctype > attr_enctype;
typedef typed_attribute < e_attribute, t_generic, a_for > attr_for;
typedef typed_attribute < e_attribute, t_id, a_form > attr_form;
typedef typed_attribute < e_attribute, t_url, a_formaction > attr_formaction;
typedef typed_attribute < e_attribute, t_enctype, a_formenctype > attr_formenctype;
typedef typed_attribute < e_attribute, t_method, a_formmethod > attr_formmethod;
typedef typed_attribute < e_attribute, t_boolean, a_formnovalidate > attr_formnovalidate;
typedef typed_attribute < e_attribute, t_target, a_formtarget > attr_formtarget;
typedef typed_attribute < e_attribute, t_integer, a_headers > attr_headers;
typedef typed_attribute < e_attribute, t_unsigned, a_height > attr_height;
typedef typed_attribute < e_attribute, t_existential, a_hidden > attr_hidden;
typedef typed_attribute < e_attribute, t_real, a_high > attr_high;
typedef typed_attribute < e_attribute, t_url, a_href > attr_href;
typedef typed_attribute < e_attribute, t_generic, a_hreflang > attr_hreflang;
typedef typed_attribute < e_attribute, t_existential, a_html > attr_html;
typedef typed_attribute < e_attribute, t_httpequiv, a_httpequiv > attr_httpequiv;
typedef typed_attribute < e_attribute, t_id, a_id > attr_id;
typedef typed_attribute < e_attribute, t_inputtype, a_inputtype > attr_inputtype;
typedef typed_attribute < e_attribute, t_text, a_integrity > attr_integrity;
typedef typed_attribute < e_attribute, t_is, a_is > attr_is;
typedef typed_attribute < e_attribute, t_boolean, a_ismap > attr_ismap;
typedef typed_attribute < e_attribute, t_url, a_itemid > attr_itemid;
typedef typed_attribute < e_attribute, t_generic, a_itemprop > attr_itemprop;
typedef typed_attribute < e_attribute, t_generic, a_itemref > attr_itemref;
typedef typed_attribute < e_attribute, t_existential, a_itemscope > attr_itemscope;
typedef typed_attribute < e_attribute, t_schema, a_itemtype > attr_itemtype;
typedef typed_attribute < e_attribute, t_kind, a_kind > attr_kind;
typedef typed_attribute < e_attribute, t_generic, a_label > attr_label;
typedef typed_attribute < e_attribute, t_lang, a_lang > attr_lang;
typedef typed_attribute < e_attribute, t_id, a_list > attr_list;
typedef typed_attribute < e_attribute, t_url, a_longdesc > attr_longdesc;
typedef typed_attribute < e_attribute, t_boolean, a_loop > attr_loop;
typedef typed_attribute < e_attribute, t_real, a_low > attr_low;
typedef typed_attribute < e_attribute, t_url, a_manifest > attr_manifest;
typedef typed_attribute < e_attribute, t_generic, a_max > attr_max;
typedef typed_attribute < e_attribute, t_integer, a_maxlength > attr_maxlength;
typedef typed_attribute < e_attribute, t_mql, a_media > attr_media;
typedef typed_attribute < e_attribute, t_metaname, a_metaname > attr_metaname;
typedef typed_attribute < e_attribute, t_generic, a_method > attr_method;
typedef typed_attribute < e_attribute, t_generic, a_min > attr_min;
typedef typed_attribute < e_attribute, t_integer, a_minlength > attr_minlength;
typedef typed_attribute < e_attribute, t_boolean, a_muted > attr_muted;
typedef typed_attribute < e_attribute, t_boolean, a_multiple > attr_multiple;
typedef typed_attribute < e_attribute, t_id, a_name > attr_name;
typedef typed_attribute < e_attribute, t_text, a_nonce > attr_nonce;
typedef typed_attribute < e_attribute, t_generic, a_novalidate > attr_novalidate;
typedef typed_attribute < e_attribute, t_javascript, a_onafterprint > attr_onafterprint;
typedef typed_attribute < e_attribute, t_javascript, a_onbeforeprint > attr_onbeforeprint;
typedef typed_attribute < e_attribute, t_javascript, a_onbeforeunload > attr_onbeforeunload;
typedef typed_attribute < e_attribute, t_javascript, a_onhashchange > attr_onhashchange;
typedef typed_attribute < e_attribute, t_javascript, a_onlanguagechange > attr_onlanguagechange;
typedef typed_attribute < e_attribute, t_javascript, a_onmessage > attr_onmessage;
typedef typed_attribute < e_attribute, t_javascript, a_onoffline > attr_onoffline;
typedef typed_attribute < e_attribute, t_javascript, a_ononline > attr_ononline;
typedef typed_attribute < e_attribute, t_javascript, a_onpagehide > attr_onpagehide;
typedef typed_attribute < e_attribute, t_javascript, a_onpageshow > attr_onpageshow;
typedef typed_attribute < e_attribute, t_javascript, a_onpopstate > attr_onpopstate;
typedef typed_attribute < e_attribute, t_javascript, a_onrejectionhandled > attr_onrejectionhandled;
typedef typed_attribute < e_attribute, t_javascript, a_onstorage > attr_onstorage;
typedef typed_attribute < e_attribute, t_javascript, a_onunhandledrejection > attr_onunhandledrejection;
typedef typed_attribute < e_attribute, t_javascript, a_onunload > attr_onunload;
typedef typed_attribute < e_attribute, t_boolean, a_open > attr_open;
typedef typed_attribute < e_attribute, t_real, a_optimum > attr_optimum;
typedef typed_attribute < e_attribute, t_regex, a_pattern > attr_pattern;
typedef typed_attribute < e_attribute, t_urls, a_ping > attr_ping;
typedef typed_attribute < e_attribute, t_generic, a_placeholder > attr_placeholder;
typedef typed_attribute < e_attribute, t_generic, a_poster > attr_poster;
typedef typed_attribute < e_attribute, t_boolean, a_preload > attr_preload;
typedef typed_attribute < e_attribute, t_generic, a_profile > attr_profile;
typedef typed_attribute < e_attribute, t_existential, a_public > attr_public;
typedef typed_attribute < e_attribute, t_boolean, a_readonly > attr_readonly;
typedef typed_attribute < e_attribute, t_referrer, a_referrerpolicy > attr_referrerpolicy;
typedef typed_attribute < e_attribute, t_generic, a_rel > attr_rel;
typedef typed_attribute < e_attribute, t_boolean, a_required > attr_required;
typedef typed_attribute < e_attribute, t_generic, a_rev > attr_rev;
typedef typed_attribute < e_attribute, t_boolean, a_reversed > attr_reversed;
typedef typed_attribute < e_attribute, t_generic, a_role > attr_role;
typedef typed_attribute < e_attribute, t_unsigned, a_rows > attr_rows;
typedef typed_attribute < e_attribute, t_integer, a_rowspan > attr_rowspan;
typedef typed_attribute < e_attribute, t_sandbox, a_sandbox > attr_sandbox;
typedef typed_attribute < e_attribute, t_scope, a_scope > attr_scope;
typedef typed_attribute < e_attribute, t_boolean, a_selected > attr_selected;
typedef typed_attribute < e_attribute, t_shape, a_shape > attr_shape;
typedef typed_attribute < e_attribute, t_unsigned, a_size > attr_size;
typedef typed_attribute < e_attribute, t_sizes, a_sizes > attr_sizes;
typedef typed_attribute < e_attribute, t_integer, a_span > attr_span;
typedef typed_attribute < e_attribute, t_step, a_step > attr_step;
typedef typed_attribute < e_attribute, t_url, a_src > attr_src;
typedef typed_attribute < e_attribute, t_html, a_srcdoc > attr_srcdoc;
typedef typed_attribute < e_attribute, t_lang, a_srclang > attr_srclang;
typedef typed_attribute < e_attribute, t_srcset, a_srcset > attr_srcset;
typedef typed_attribute < e_attribute, t_truefalse, a_spellcheck > attr_spellcheck;
typedef typed_attribute < e_attribute, t_unsigned, a_start > attr_start;
typedef typed_attribute < e_attribute, t_css, a_style > attr_style;
typedef typed_attribute < e_attribute, t_existential, a_system > attr_system;
typedef typed_attribute < e_attribute, t_integer, a_tabindex > attr_tabindex;
typedef typed_attribute < e_attribute, t_target, a_target > attr_target;
typedef typed_attribute < e_attribute, t_text, a_title > attr_title;
typedef typed_attribute < e_attribute, t_yesno, a_translate > attr_translate;
typedef typed_attribute < e_attribute, t_mime, a_type > attr_type;
typedef typed_attribute < e_attribute, t_boolean, a_typemustmatch > attr_typemustmatch;
typedef typed_attribute < e_attribute, t_generic, a_usemap > attr_usemap;
typedef typed_attribute < e_attribute, t_generic, a_value > attr_value;
typedef typed_attribute < e_attribute, t_unsigned, a_width > attr_width;
typedef typed_attribute < e_attribute, t_integer, a_wrap > attr_wrap;
typedef typed_attribute < e_attribute, t_illegal, a_xmlbase > attr_xmlbase;
typedef typed_attribute < e_attribute, t_lang, a_xmllang > attr_xmllang;
typedef typed_attribute < e_attribute, t_generic, a_xmlns > attr_xmlns;
